## appstream 0.10.1

=== CMakeLists.txt ===
# CMakeLists for the AppStream Project
project(appstream)
cmake_minimum_required(VERSION 3.2.0 FATAL_ERROR)

set(CMAKE_BUILD_TYPE "Debug")

set(AS_VERSION_MAJOR  "0")
set(AS_VERSION_MINOR  "10")
set(AS_VERSION_PATCH  "1")
set(AS_VERSION "${AS_VERSION_MAJOR}.${AS_VERSION_MINOR}.${AS_VERSION_PATCH}")
set(APPSTREAM_LIB_API_LEVEL "4")

# Don't allow in-tree building
if(${CMAKE_SOURCE_DIR} MATCHES ${CMAKE_BINARY_DIR})
      message(STATUS "Please do an out-of-tree build:")
      message(STATUS "rm -f CMakeCache.txt && mkdir build && cd build; cmake .. && make")
      message(FATAL_ERROR "In-tree-build detected!")
endif(${CMAKE_SOURCE_DIR} MATCHES ${CMAKE_BINARY_DIR})

#
# Options
#
option(L18N "Enable localization" ON)
option(STEMMING "Use stemming while searching. Requires Snowball (libstemmer)" ON)
option(VAPI "Create and install a Vala API file" OFF)
option(QT "Build libappstream-qt" OFF)
option(MAINTAINER "Enable maintainer mode (use strict compiler flags, e.g. -Werror)" OFF)
option(DOCUMENTATION "Enable target to build documentation" OFF)
option(APT_SUPPORT "Enable integration with APT on Debian" OFF)
option(SANITIZERS "Compile with sanitizers (address / thread sanitizer) enabled. Requires maintainer mode to be ON too." OFF)

#
# Default paths
#
if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  set(CMAKE_INSTALL_PREFIX
    "/usr" CACHE PATH "Default install prefix" FORCE)
endif(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)

# Special case for /etc and /var when prefix is /usr
if(${CMAKE_INSTALL_PREFIX} STREQUAL "/usr")
  set(CMAKE_INSTALL_SYSCONFDIR "/etc" CACHE PATH "read-only single-machine data (etc)")
  set(CMAKE_INSTALL_LOCALSTATEDIR "/var" CACHE PATH "modifiable single-machine data (var)")
endif(${CMAKE_INSTALL_PREFIX} STREQUAL "/usr")
set(CMAKE_INSTALL_METAINFODIR "share/metainfo" CACHE PATH "AppStream metainfo directory")
include(GNUInstallDirs)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/data/cmake/)

message(STATUS "Compiling AppStream version ${AS_VERSION}")

add_custom_target(distclean
  "make clean"
)

#
# l18n
#
find_package (Gettext REQUIRED)

#
# Configure files
#
set (GETTEXT_PACKAGE "appstream")
set (VERSION "${AS_VERSION}")
if(APT_SUPPORT)
	set (HAVE_APT_SUPPORT true)
endif()
if(STEMMING)
	set (HAVE_STEMMING true)
endif()
configure_file(config.h.in ${CMAKE_BINARY_DIR}/config.h)

#
# Enable testing
#
enable_testing()

#
# Custom C flags
#
set(MAINTAINER_CFLAGS "")
set(SANITIZER_LIBS "")
if(MAINTAINER)
	set(MAINTAINER_CFLAGS "-Werror"
			"-Wall"
			"-Wextra"
			"-Wcast-align"
			"-Wno-uninitialized"
			"-Wempty-body"
			"-Wformat-security"
			"-Winit-self"
			"-Wnull-dereference"
			"-Wfloat-equal"
			#"-Wformat-signedness"
			"-Winline")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wmissing-declarations")
	if (CMAKE_COMPILER_IS_GNUCC)
		execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpversion
                OUTPUT_VARIABLE GCC_VERSION)
		if (GCC_VERSION VERSION_GREATER 4.9 OR GCC_VERSION VERSION_EQUAL 4.9)
			set(MAINTAINER_CFLAGS ${MAINTAINER_CFLAGS} "-fdiagnostics-color=auto")
		endif()
	endif()

	if(SANITIZERS)
		set(MAINTAINER_CFLAGS ${MAINTAINER_CFLAGS} "-fsanitize=address" "-fsanitize=undefined")
		set(SANITIZER_LIBS "asan" "ubsan")
		if ("${CMAKE_C_COMPILER_ID}" STREQUAL "Clang")
			set(MAINTAINER_CFLAGS ${MAINTAINER_CFLAGS} "-fno-sanitize-recover=undefined,integer")
		else()
			set(MAINTAINER_CFLAGS ${MAINTAINER_CFLAGS} "-fno-sanitize-recover")
		endif()
	endif()
endif(MAINTAINER)
add_definitions(${MAINTAINER_CFLAGS})

# a few compiler warning flags we always want enabled
add_definitions("-Werror=implicit-function-declaration" "-Wno-unused-parameter")

# enable C++11
set(CMAKE_CXX_STANDARD "11")

find_package(PkgConfig REQUIRED)

add_subdirectory(src)
add_subdirectory(tools)
add_subdirectory(data)
add_subdirectory(contrib)
add_subdirectory(po)
add_subdirectory(docs)
add_subdirectory(tests)
if(QT)
	add_subdirectory(qt)
endif()

=== data/CMakeLists.txt ===
# CMakeLists for UAI data directory

find_program (LC_INTLTOOL_MERGE intltool-merge)
mark_as_advanced (LC_INTLTOOL_MERGE)

if (LC_INTLTOOL_MERGE STREQUAL "LC_INTLTOOL_MERGE-NOTFOUND")
	message (FATAL_ERROR "Intltool was not found! Please install it to continue!")
endif (LC_INTLTOOL_MERGE STREQUAL "LC_INTLTOOL_MERGE-NOTFOUND")

install(FILES appstream.conf
	DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}
)

install(FILES org.freedesktop.appstream.cli.metainfo.xml
	DESTINATION ${CMAKE_INSTALL_METAINFODIR}
)

=== po/CMakeLists.txt ===
# CMakeLists for AppStream localisation

find_program (LC_INTLTOOL_UPDATE intltool-update)
mark_as_advanced (LC_INTLTOOL_UPDATE)

find_package (Gettext REQUIRED)

if (LC_INTLTOOL_UPDATE STREQUAL "")
	message (FATAL_ERROR "Intltool was not found! Please install it to continue!")
endif (LC_INTLTOOL_UPDATE STREQUAL "")

set(LPKNAME "appstream")

add_custom_target (l10n-update
	${LC_INTLTOOL_UPDATE} -p -g "${LPKNAME}"
	DEPENDS POTFILES.in
	WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)

add_custom_target (l10n-maintain
	${LC_INTLTOOL_UPDATE} -m "${LPKNAME}"
	DEPENDS POTFILES.in
	WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)

file (GLOB _translations ${CMAKE_CURRENT_SOURCE_DIR}/*.po)
        gettext_create_translations (${LPKNAME}.pot
				     ALL ${_translations}
)

=== qt/CMakeLists.txt ===
project(AppstreamQt)
cmake_minimum_required(VERSION 3.2.0 FATAL_ERROR)

include(CMakePackageConfigHelpers)
include(GenerateExportHeader)
add_compiler_export_flags()

find_package(Qt5 REQUIRED COMPONENTS Core)
pkg_check_modules(GLIB2 REQUIRED glib-2.0>=2.46)
include(GNUInstallDirs)

set(APPSTREAMQT_SO_VERSION 1)
set(APPSTREAMQT_VERSION ${AS_VERSION})

set(CMAKE_AUTOMOC on)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_INCLUDE_CURRENT_DIR_IN_INTERFACE ON)
set(CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE ON)

if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

set(APPSTREAMQT_SRC
          component.cpp
          database.cpp
          image.cpp
          provides.cpp
          screenshot.cpp
          release.cpp
)

set(APPSTREAMQT_PUBLIC_HEADERS
    component.h
    database.h
    image.h
    provides.h
    screenshot.h
    release.h
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}
                    ${CMAKE_SOURCE_DIR}/src
                    ${CMAKE_BINARY_DIR}/src
                    ${GLIB2_INCLUDE_DIRS}
)

add_library(AppstreamQt SHARED ${APPSTREAMQT_SRC})
target_link_libraries(AppstreamQt PUBLIC Qt5::Core
                                  PRIVATE appstream
                                          ${GLIB2_LIBRARIES}
                                          ${SANITIZER_LIBS})
target_include_directories(AppstreamQt PUBLIC "$<INSTALL_INTERFACE:${${CMAKE_INSTALL_INCLUDEDIR}}/>")
generate_export_header(AppstreamQt)

set_property(TARGET AppstreamQt PROPERTY VERSION "${APPSTREAMQT_VERSION}")
set_property(TARGET AppstreamQt PROPERTY SOVERSION "${APPSTREAMQT_SO_VERSION}" )

write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/AppstreamQtConfigVersion.cmake VERSION ${APPSTREAMQT_VERSION} COMPATIBILITY SameMajorVersion )

export(TARGETS AppstreamQt appstream
       FILE "${CMAKE_CURRENT_BINARY_DIR}/AppstreamQtTargets.cmake")

install(TARGETS AppstreamQt EXPORT AppStreamLibsTarget
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

install(FILES ${APPSTREAMQT_PUBLIC_HEADERS} ${CMAKE_CURRENT_BINARY_DIR}/appstreamqt_export.h DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/AppstreamQt")

set(ConfigPackageLocation ${CMAKE_INSTALL_LIBDIR}/cmake/AppstreamQt)

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/AppstreamQtConfig.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/AppstreamQtConfig.cmake"
  @ONLY
)

install(EXPORT AppStreamLibsTarget
    FILE AppstreamQtTargets.cmake
    DESTINATION ${ConfigPackageLocation})

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/AppstreamQtConfigVersion.cmake ${CMAKE_CURRENT_BINARY_DIR}/AppstreamQtConfig.cmake DESTINATION ${ConfigPackageLocation})

add_subdirectory(test)

=== src/CMakeLists.txt ===
# CMakeLists for AppStream database shared lib

pkg_check_modules(GLIB2 REQUIRED glib-2.0>=2.46)
pkg_check_modules(GIO2 REQUIRED gio-2.0)
find_package(GI REQUIRED)
find_package(LibXml2 REQUIRED)
find_library(M_LIB m)
pkg_check_modules(YAML REQUIRED yaml-0.1)

if (STEMMING)
	find_library(SNOWBALL_LIB stemmer)
	if (NOT SNOWBALL_LIB)
		message (FATAL_ERROR "Stemming support is enabled, but libstemmer was not found. Please install the Snowball development files.")
	endif ()
endif ()

include(GObjectIntrospectionMacros)
set(INTROSPECTION_GIRS)
set(INTROSPECTION_SCANNER_ARGS "--identifier-prefix=As" "--symbol-prefix=as" "--warn-all" "--add-include-path=${CMAKE_CURRENT_SOURCE_DIR}")
set(INTROSPECTION_COMPILER_ARGS "--includedir=${CMAKE_CURRENT_SOURCE_DIR}")

# check if the git tools are really found.
if (NOT INTROSPECTION_SCANNER)
	message (FATAL_ERROR "GObject introspection scanner was not found! Please install it to continue.")
endif ()
if (NOT INTROSPECTION_COMPILER)
	message (FATAL_ERROR "GObject introspection compiler was not found! Please install it to continue.")
endif ()

set (srcdir ${CMAKE_CURRENT_SOURCE_DIR} CACHE INTERNAL "Source dir")
set(AS_VERSION_BASE "${AS_VERSION_MAJOR}.${AS_VERSION_MINOR}" CACHE INTERNAL "AppStream library combined version number")

set(APPSTREAM_LIB_SRC
		as-utils.c
		# internal
		as-xmldata.c
		as-yamldata.c
		as-cache-file.c
		as-distro-extras.c
		as-stemmer.c
		# (mostly) public
		as-spdx.c
		as-metadata.c
		as-component.c
		as-enums.c
		as-provided.c
		as-bundle.c
		as-pool.c
		as-category.c
		as-distro-details.c
		as-screenshot.c
		as-image.c
		as-release.c
		as-checksum.c
		as-validator.c
		as-validator-issue.c
		as-icon.c
		as-translation.c
		as-suggested.c
)

set(APPSTREAM_LIB_PUBLIC_HEADERS
		appstream.h
		as-utils.h
		as-spdx.h
		as-metadata.h
		as-component.h
		as-pool.h
		as-enums.h
		as-provided.h
		as-bundle.h
		as-category.h
		as-distro-details.h
		as-screenshot.h
		as-image.h
		as-release.h
		as-checksum.h
		as-validator.h
		as-validator-issue.h
		as-icon.h
		as-translation.h
		as-suggested.h
)

set(APPSTREAM_LIB_PRIVATE_HEADERS
		as-utils-private.h
		as-xmldata.h
		as-yamldata.h
		as-cache-file.h
		as-pool-private.h
		as-component-private.h
		as-screenshot-private.h
		as-release-private.h
		as-distro-extras.h
		as-stemmer.h
)

include_directories(${CMAKE_BINARY_DIR}
		    ${CMAKE_BINARY_DIR}/src
		    ${GLIB2_INCLUDE_DIRS}
		    ${GIO2_INCLUDE_DIRS}
		    ${LIBXML2_INCLUDE_DIR}
		    ${YAML_INCLUDE_DIR}
)

add_definitions("-DAS_COMPILATION")

# ensure that the GI compiler has been found (apparently, the automatic tests fail on some machines)
if (NOT INTROSPECTION_COMPILER)
  message(FATAL_ERROR "GObject-Introspection was not found! Please install it to continue.")
endif()

# GResources
find_program (GCR_TOOL glib-compile-resources)
if (NOT GCR_TOOL)
	message(FATAL_ERROR "Could not find glib-compile-resources! Please mek the tool available to continue.")
endif ()

add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/as-resources.h
	DEPENDS appstream.gresource.xml
		${CMAKE_SOURCE_DIR}/data/xdg-category-names.txt
	COMMAND ${GCR_TOOL}
		"--sourcedir=${CMAKE_SOURCE_DIR}/data"
		"--target=as-resources.h"
		"--generate-header"
		"--c-name=as"
		"${CMAKE_CURRENT_SOURCE_DIR}/appstream.gresource.xml"
	WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
	VERBATIM
)

add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/as-resources.c
	DEPENDS appstream.gresource.xml
		${CMAKE_SOURCE_DIR}/data/xdg-category-names.txt
	COMMAND ${GCR_TOOL}
		"--sourcedir=${CMAKE_SOURCE_DIR}/data"
		"--target=as-resources.c"
		"--generate-source"
		"--c-name=as"
		"${CMAKE_CURRENT_SOURCE_DIR}/appstream.gresource.xml"
	WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
	VERBATIM
)

set (APPSTREAM_LIB_GRESOURCE ${CMAKE_CURRENT_BINARY_DIR}/as-resources.c
			      ${CMAKE_CURRENT_BINARY_DIR}/as-resources.h
)

add_library(appstream SHARED
		${APPSTREAM_LIB_SRC}
		${APPSTREAM_LIB_PUBLIC_HEADERS}
		${APPSTREAM_LIB_PRIVATE_HEADERS}
		${APPSTREAM_LIB_GRESOURCE}
)

set_target_properties(appstream PROPERTIES VERSION ${AS_VERSION} SOVERSION ${APPSTREAM_LIB_API_LEVEL})

target_link_libraries(appstream
		${SANITIZER_LIBS}
		${GLIB2_LIBRARIES}
		${GIO2_LIBRARIES}
		${LIBXML2_LIBRARIES}
		${YAML_LIBRARIES}
		${SNOWBALL_LIB}
)

configure_file (${CMAKE_CURRENT_SOURCE_DIR}/appstream.pc.in ${CMAKE_CURRENT_BINARY_DIR}/appstream.pc @ONLY)

####
# GObject Introspection

if(NOT (MAINTAINER AND SANITIZERS))
# compiling GIR doesn't work well with asan, needs to be investigated.

macro(_list_prefix _outvar _listvar _prefix)
  set(${_outvar})
  foreach(_item IN LISTS ${_listvar})
    list(APPEND ${_outvar} ${_prefix}${_item})
  endforeach()
endmacro(_list_prefix)

set(introspection_files ${APPSTREAM_LIB_SRC} ${APPSTREAM_LIB_PUBLIC_HEADERS})
set(AppStream_1_0_gir "appstream")
set(AppStream_1_0_gir_INCLUDES GObject-2.0 Gio-2.0)
set(AppStream_1_0_gir_CFLAGS "-I${CMAKE_CURRENT_SOURCE_DIR}/" "-DAS_COMPILATION" ${MAINTAINER_CFLAGS})
set(AppStream_1_0_gir_LIBS appstream)

_list_prefix(AppStream_1_0_gir_FILES introspection_files "${CMAKE_CURRENT_SOURCE_DIR}/")
set(AppStream_1_0_gir_SCANNERFLAGS --c-include appstream.h)
set(AppStream_1_0_gir_EXPORT_PACKAGES appstream)

list(APPEND INTROSPECTION_GIRS AppStream-1.0.gir)
gir_add_introspections(INTROSPECTION_GIRS)

endif()
####

install(TARGETS appstream EXPORT AppStreamLibsTarget DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES ${APPSTREAM_LIB_PUBLIC_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/AppStream)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/appstream.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig/)

=== contrib/vapi/CMakeLists.txt ===
# Vala API

if(NOT (MAINTAINER AND SANITIZERS))
# compiling GIR doesn't work well with asan, needs to be investigated.

set(APPSTREAM_VAPI_FILE "${CMAKE_CURRENT_BINARY_DIR}/appstream.vapi")

find_program (VAPIGEN vapigen)
mark_as_advanced (VAPIGEN)
if (VAPIGEN STREQUAL "VAPIGEN-NOTFOUND")
	message (FATAL_ERROR "Vapigen was not found. Please install it in order to generate Vala API files!")
endif (VAPIGEN STREQUAL "VAPIGEN-NOTFOUND")

add_custom_command (OUTPUT ${APPSTREAM_VAPI_FILE}
			COMMAND ${VAPIGEN} --metadatadir=${CMAKE_CURRENT_SOURCE_DIR} -d . --vapidir=${CMAKE_CURRENT_SOURCE_DIR}
					${CMAKE_BINARY_DIR}/src/AppStream-1.0.gir
					--library=appstream
					--pkg glib-2.0 --pkg gio-2.0 --pkg gobject-2.0
			WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
			DEPENDS appstream gir-typelibs ${CMAKE_BINARY_DIR}/src/AppStream-1.0.typelib
			VERBATIM
)
add_custom_target(vapi ALL DEPENDS ${APPSTREAM_VAPI_FILE})

install(FILES ${APPSTREAM_VAPI_FILE} DESTINATION share/vala/vapi)

endif()

=== qt/test/CMakeLists.txt ===

find_package(Qt5 COMPONENTS Test REQUIRED)

configure_file (${CMAKE_CURRENT_SOURCE_DIR}/testpaths.h.in ${CMAKE_CURRENT_BINARY_DIR}/testpaths.h @ONLY)

add_executable(qt-cache-read-test qtcachereadtest.cpp)
target_link_libraries(qt-cache-read-test
    ${SANITIZER_LIBS}
    Qt5::Core
    Qt5::Test
    AppstreamQt
)
add_test(qt-cache-read-test qt-cache-read-test)

if(SANITIZERS)
	set_tests_properties(qt-cache-read-test PROPERTIES ENVIRONMENT ASAN_OPTIONS=detect_leaks=0)
endif()

=== debian/changelog ===
appstream (0.10.1-1) unstable; urgency=medium

  * New upstream release: 0.10.1
  * Drop patches: Applied upstream
  * Fix GIR package name and use GIR dh addon (Closes: #837684)
  * Add more multiarch metadata
  * Properly clean up the global cache on purge

 -- Matthias Klumpp <mak@debian.org>  Fri, 16 Sep 2016 14:28:38 +0200

appstream (0.10.0-2) unstable; urgency=medium

  * cache-serialization.patch: Correctly (de)serialize screenshot data
  * yaml-screenshot-image-type.patch: Set correct image type when
    reading YAML
  * addons-find-target.patch: Fix addon/target associations

 -- Matthias Klumpp <mak@debian.org>  Wed, 31 Aug 2016 22:34:06 +0200

appstream (0.10.0-1) unstable; urgency=medium

  * New upstream release: 0.10.0
  * Refresh dependencies
  * Build with stemming support
  * Drop all patches: Applied upstream
  * Update symbols file for ABI break

 -- Matthias Klumpp <mak@debian.org>  Tue, 30 Aug 2016 22:48:30 +0200

appstream (0.9.8-4) unstable; urgency=medium

  * cache-translate-urls.patch: Make cache aware of
    'translate' URLs (LP: #1614375)

 -- Matthias Klumpp <mak@debian.org>  Thu, 18 Aug 2016 20:28:56 +0200

appstream (0.9.8-3) unstable; urgency=medium

  * Fix cache update in postinst (Closes: #834136)
  * unittest-32bit-fix.patch: Fix build on 32bit architectures
    (Closes: #834124)

 -- Matthias Klumpp <mak@debian.org>  Tue, 16 Aug 2016 19:19:02 +0200

appstream (0.9.8-2) unstable; urgency=medium

  * unittest-arm-fix.patch: Resolve FTBFS on ARM due to
    failing unittests
  * Make libas-dev package depend on the GIR

 -- Matthias Klumpp <mak@debian.org>  Thu, 11 Aug 2016 20:02:18 +0200

appstream (0.9.8-1) unstable; urgency=medium

  * New upstream release: 0.9.8
  * Update symbols file

 -- Matthias Klumpp <mak@debian.org>  Wed, 10 Aug 2016 22:48:52 +0200

appstream (0.9.7-1) unstable; urgency=medium

  * New upstream release: 0.9.7
  * Update package descriptions
  * Update .symbols file

 -- Matthias Klumpp <mak@debian.org>  Wed, 20 Jul 2016 16:58:46 +0200

appstream (0.9.6-1) unstable; urgency=medium

  * New upstream release: 0.9.6

 -- Matthias Klumpp <mak@debian.org>  Thu, 12 May 2016 18:44:26 +0200

appstream (0.9.5-1) unstable; urgency=medium

  * New upstream release: 0.9.5
  * Drop patches: Applied upstream
  * Update .symbols file

 -- Matthias Klumpp <mak@debian.org>  Mon, 02 May 2016 18:48:14 +0200

appstream (0.9.4-2) unstable; urgency=medium

  * Update .symbols file
  * iconfinding-refactor.patch: Update iconfinding code,
    resolves double-free issue (Closes: #822317)

 -- Matthias Klumpp <mak@debian.org>  Fri, 22 Apr 2016 17:08:14 +0200

=== debian/control ===
Source: appstream
Section: admin
Priority: optional
Maintainer: Matthias Klumpp <mak@debian.org>
Build-Depends: cmake (>= 2.8),
               debhelper (>= 9.0.0),
               gobject-introspection,
               gtk-doc-tools,
               intltool,
               libgirepository1.0-dev (>= 1.32),
               libglib2.0-dev (>= 2.46),
               libstemmer-dev,
               libxml2-dev (>= 2.8.0),
               libyaml-dev (>= 0.1.6),
               qtbase5-dev (>= 5.4),
               valac,
               xmlto
Standards-Version: 3.9.8
Homepage: http://www.freedesktop.org/wiki/Distributions/AppStream/
Vcs-Git: https://anonscm.debian.org/git/pkg-packagekit/appstream.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-packagekit/appstream.git

Package: appstream
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Breaks: appstream-index (<< ${source:Version})
Provides: appstream-index
Description: Software component metadata management
 AppStream is a metadata specification, allowing to write metadata for
 software projects in a general-purpose format.
 It provides facilities to easily access and transform the data, as well
 as a few additional services to allow building feature-rich software center
 applications.
 .
 This package provides tools to generate, maintain and query the AppStream
 data pool of installed and available software, and enables integration
 with the APT package manager.
 .
 The 'appstreamcli' tool can be used for accessing the software component
 pool as well as for working with AppStream metadata directly, including
 validating it for compliance with the specification.

Package: libappstream4
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Library to access AppStream services
 AppStream is a metadata specification, allowing to write metadata for
 software projects in a general-purpose format. This allows software centers
 to display useful information for not installed software, as well as
 determining software the user might want to install (e.g. to open an
 unknown file type or to make missing firmware available).
 .
 This package contains a GObject-based library to access AppStream
 services, like the software component metadata pool.
 It also contains functions for reading, writing and transforming AppStream
 metadata.

Package: libappstream-dev
Architecture: any
Section: libdevel
Depends: gir1.2-appstream-1.0 (= ${binary:Version}),
         libappstream4 (= ${binary:Version}),
         libglib2.0-dev (>= 2.46),
         ${misc:Depends}
Suggests: appstream-generator
Description: Library to access AppStream services (development files)
 AppStream is a metadata specification, allowing to write metadata for
 software projects in a general-purpose format. This allows software centers
 to display useful information for not installed software, as well as
 determining software the user might want to install (e.g. to open an
 unknown file type or to make missing firmware available).
 .
 This package contains development files necessary to develop
 software management tools which use the AppStream library.

Package: gir1.2-appstream-1.0
Architecture: any
Section: introspection
Depends: libappstream4 (= ${binary:Version}),
         ${gir:Depends},
         ${misc:Depends}
Breaks: gir1.2-appstream (<< 0.10.1)
Replaces: gir1.2-appstream (<< 0.10.1)
Description: Library to access AppStream services (introspection data)
 AppStream is a metadata specification, allowing to write metadata for
 software projects in a general-purpose format. This allows software centers
 to display useful information for not installed software, as well as
 determining software the user might want to install (e.g. to open an
 unknown file type or to make missing firmware available).
 .
 This package contains introspection data for the AppStream library.

Package: libappstreamqt1
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Qt5 library to access AppStream services
 AppStream is a metadata specification, allowing to write metadata for
 software projects in a general-purpose format. This allows software centers
 to display useful information for not installed software, as well as
 determining software the user might want to install (e.g. to open an
 unknown file type or to make missing firmware available).
 .
 This package contains a Qt-based library to access AppStream
 services, like the software component metadata pool.

Package: libappstreamqt-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libappstreamqt1 (= ${binary:Version}),
         qtbase5-dev (>= 5.4),
         ${misc:Depends}
Description: Qt5 library to access AppStream services (development files)
 AppStream is a metadata specification, allowing to write metadata for
 software projects in a general-purpose format. This allows software centers
 to display useful information for not installed software, as well as
 determining software the user might want to install (e.g. to open an
 unknown file type or to make missing firmware available).
 .
 This package contains development files necessary to develop
 software management tools which use the Qt-based AppStream library.

Package: appstream-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Suggests: appstream
Description: Developer documentation for AppStream
 AppStream is a metadata specification, allowing to write metadata for
 software projects in a general-purpose format. This allows software centers
 to display useful information for not installed software, as well as
 determining software the user might want to install (e.g. to open an
 unknown file type or to make missing firmware available).
 .
 This package provides developer documentation for AppStream.

Package: appstream-index
Architecture: all
Section: oldlibs
Priority: extra
Depends: appstream (>= ${source:Version}),
         ${misc:Depends}
Description: Transitional package (appstream-index -> appstream)
 Transitional dummy package replacing appstream-index with
 appstream.

## appstream 0.10.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 set(AS_VERSION_MAJOR  "0")
 set(AS_VERSION_MINOR  "10")
-set(AS_VERSION_PATCH  "1")
+set(AS_VERSION_PATCH  "6")
 set(AS_VERSION "${AS_VERSION_MAJOR}.${AS_VERSION_MINOR}.${AS_VERSION_PATCH}")
 set(APPSTREAM_LIB_API_LEVEL "4")
 
@@ -42,7 +42,6 @@
   set(CMAKE_INSTALL_SYSCONFDIR "/etc" CACHE PATH "read-only single-machine data (etc)")
   set(CMAKE_INSTALL_LOCALSTATEDIR "/var" CACHE PATH "modifiable single-machine data (var)")
 endif(${CMAKE_INSTALL_PREFIX} STREQUAL "/usr")
-set(CMAKE_INSTALL_METAINFODIR "share/metainfo" CACHE PATH "AppStream metainfo directory")
 include(GNUInstallDirs)
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/data/cmake/)
 
@@ -120,6 +119,7 @@
 # enable C++11
 set(CMAKE_CXX_STANDARD "11")
 
+include(CMakePackageConfigHelpers)
 find_package(PkgConfig REQUIRED)
 
 add_subdirectory(src)

=== data/CMakeLists.txt ===
# CMakeLists for AppStream data directory

find_program (ITSTOOL itstool)
mark_as_advanced (ITSTOOL)

if (NOT ITSTOOL)
	message (FATAL_ERROR "Itstool was not found. Please install it to continue.")
endif ()

install(FILES appstream.conf
	DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}
)

add_custom_target (merge-l10n ALL
	${ITSTOOL}
		-i ${CMAKE_SOURCE_DIR}/contrib/its/metainfo.its
		-j ${CMAKE_CURRENT_SOURCE_DIR}/org.freedesktop.appstream.cli.metainfo.xml
		-o ${CMAKE_CURRENT_BINARY_DIR}/org.freedesktop.appstream.cli.metainfo.xml
		${CMAKE_BINARY_DIR}/po/*.gmo
	DEPENDS org.freedesktop.appstream.cli.metainfo.xml translations_1
	WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.freedesktop.appstream.cli.metainfo.xml
	DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/metainfo
)

=== docs/CMakeLists.txt ===
# CMakeLists for documentation

find_program (XMLTO xmlto)
mark_as_advanced (XMLTO)
if (XMLTO STREQUAL "XMLTO-NOTFOUND")
	message (FATAL_ERROR "Xmlto was not found! Please install it to continue!")
endif (XMLTO STREQUAL "XMLTO-NOTFOUND")

include (${CMAKE_SOURCE_DIR}/data/cmake/documentation.cmake)

add_xml_manpages(doc-man-asi "sources/man/appstreamcli.1" "" "")

set(DOC_HTML_EXPORT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/html")

if (DOCUMENTATION)
	#########################
	# General project documentation
	find_program (PUBLICAN publican)
	mark_as_advanced (PUBLICAN)
	if (NOT PUBLICAN)
		message (FATAL_ERROR "Publican was not found. Please install it to continue!")
	endif ()

	# we need to assemble our documentation build-directory before we can built it
	add_custom_target (assemble-docs
		COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/prepare-docbuild.sh" "source_dir=${CMAKE_CURRENT_SOURCE_DIR}" "build_dir=${CMAKE_BINARY_DIR}/docbuild"
		DEPENDS "publican.cfg"
			"sources/"
			"${CMAKE_BINARY_DIR}/docbuild/"
			appstream
		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
		VERBATIM
	)

	# the actual target to build all documentation
	add_custom_target (documentation-noexport
		COMMAND ${PUBLICAN} "build" "--langs=en-US" "--publish" "--formats=html"
		DEPENDS "publican.cfg"
			"${CMAKE_BINARY_DIR}/docbuild/publican.cfg"
			assemble-docs
			doc-appstream
		WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/docbuild/
	)
	add_custom_command (OUTPUT "${CMAKE_BINARY_DIR}/docbuild/"
			COMMAND ${CMAKE_COMMAND} -E make_directory "${CMAKE_BINARY_DIR}/docbuild"
			VERBATIM
	)

	set_directory_properties (PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES ${DOC_HTML_EXPORT_DIR})
	set_directory_properties (PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES ${CMAKE_BINARY_DIR}/docbuild)

	# a target to export documentation html to the source tree (useful when building the tarballs)
	add_custom_target (documentation
		COMMAND ${CMAKE_COMMAND} -E copy_directory "${CMAKE_BINARY_DIR}/docbuild/AppStream-Docs/en-US/html/" "${DOC_HTML_EXPORT_DIR}"
		DEPENDS documentation-noexport
		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
	)
	add_custom_command(
		TARGET documentation POST_BUILD
		COMMAND ${CMAKE_COMMAND} -E copy_directory "${CMAKE_CURRENT_SOURCE_DIR}/api/html" "${DOC_HTML_EXPORT_DIR}/api"
		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
	)

	#########################
	# API documentation

	find_package(GtkDoc)
	if(NOT GTKDOC_FOUND)
		message(FATAL_ERROR "gtkdoc was not found, API documentation can not be built.")
	endif()
	include(UseGtkDoc)

	gtk_doc_add_module(appstream ${CMAKE_SOURCE_DIR}/src
		IGNOREHEADERS as-component-private.h as-utils-private.h as-settings-private.h as-cache-internal.h
		SUFFIXES h c hh cc
		LDFLAGS
			-L${CMAKE_CURRENT_BINARY_DIR}/../src
			-lappstream
		LDPATH
			"${CMAKE_CURRENT_BINARY_DIR}/../src"
		OUTPUT_DIR
			"${CMAKE_CURRENT_SOURCE_DIR}/api"
		DEPENDS appstream)

	set_directory_properties (PROPERTIES CLEAN_NO_CUSTOM ${CMAKE_CURRENT_SOURCE_DIR}/api)
	set_directory_properties (PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "${CMAKE_CURRENT_SOURCE_DIR}/api/html;${CMAKE_CURRENT_SOURCE_DIR}/api/xml;${CMAKE_CURRENT_SOURCE_DIR}/api/tmpl")

	#file(GLOB EXTRA_CLEANUP_FILES   "${CMAKE_CURRENT_SOURCE_DIR}/api/*.txt"
	#				"${CMAKE_CURRENT_SOURCE_DIR}/api/*.stamp"
	#				"${CMAKE_CURRENT_SOURCE_DIR}/api/*.c"
	#				"${CMAKE_CURRENT_SOURCE_DIR}/api/*.bak"
	#)
	#set(EXTRA_CLEANUP_FILES_LIST "")
	#foreach(fname ${EXTRA_CLEANUP_FILES})
	#	list(APPEND EXTRA_CLEANUP_FILES_LIST "${fname}")
	#endforeach(fname)

	#set_directory_properties (PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "${EXTRA_CLEANUP_FILES_LIST}")
endif()

option(INSTALL_PREBUILT_DOCS "Install prebuilt documentation, if found" ON)
if (INSTALL_PREBUILT_DOCS OR DOCUMENTATION)
	if (DOCUMENTATION OR (EXISTS "${DOC_HTML_EXPORT_DIR}" AND IS_DIRECTORY "${DOC_HTML_EXPORT_DIR}"))
		install(DIRECTORY "${DOC_HTML_EXPORT_DIR}/" DESTINATION ${CMAKE_INSTALL_DATADIR}/doc/appstream/html)

		install(DIRECTORY DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/gtk-doc/html/)
		install(CODE "if (\"\$ENV{DESTDIR}\" STREQUAL \"\")
					execute_process (COMMAND \"${CMAKE_COMMAND}\" -E create_symlink
						${CMAKE_INSTALL_FULL_DATADIR}/doc/appstream/html/api/
						${CMAKE_INSTALL_FULL_DATADIR}/gtk-doc/html/appstream
					)
				else ()
					execute_process (COMMAND \"${CMAKE_COMMAND}\" -E create_symlink
						${CMAKE_INSTALL_FULL_DATADIR}/doc/appstream/html/api/
						\$ENV{DESTDIR}/${CMAKE_INSTALL_FULL_DATADIR}/gtk-doc/html/appstream
					)
				endif ()")
	endif()
endif()

=== po/CMakeLists.txt ===
# CMakeLists for AppStream localisation

find_program (XGETTEXT xgettext)
mark_as_advanced (XGETTEXT)

find_program (ITSTOOL itstool)
mark_as_advanced (ITSTOOL)

find_package (Gettext REQUIRED)

if (NOT XGETTEXT)
	message (FATAL_ERROR "Xgettext was not found. Please install it to continue.")
endif()
if (NOT ITSTOOL)
	message (FATAL_ERROR "Itstool was not found. Please install it to continue.")
endif()

set(XGETTEXT_OPTIONS --from-code=UTF-8
		--keyword=_ --keyword=N_ --keyword=C_:1c,2 --keyword=NC_:1c,2
		-i -s --no-wrap -c
		--package-name=appstream
		"--copyright-holder=Matthias Klumpp"
		"--msgid-bugs-address=appstream@lists.freedesktop.org"
)

set(XML_FILES
	../data/org.freedesktop.appstream.cli.metainfo.xml
)

set(LPKNAME appstream)

set(XML_TMP_POT "${CMAKE_CURRENT_BINARY_DIR}/${LPKNAME}-xmlfiles.pot")
add_custom_command (OUTPUT ${XML_TMP_POT}
	COMMAND ${ITSTOOL} --output=${XML_TMP_POT}
			--its=${CMAKE_SOURCE_DIR}/contrib/its/metainfo.its
			${XML_FILES}
	DEPENDS ${XML_FILES}
	WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)

add_custom_target (l10n-update
	${XGETTEXT}
		${XGETTEXT_OPTIONS}
		--files-from=SRCFILES
		--directory=${CMAKE_SOURCE_DIR}
		${XML_TMP_POT}
		--output=${LPKNAME}.pot
	DEPENDS SRCFILES ${XML_TMP_POT}
	WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)

file (GLOB _translations ${CMAKE_CURRENT_SOURCE_DIR}/*.po)
        gettext_create_translations (${LPKNAME}.pot
				     ALL ${_translations}
)

=== qt/CMakeLists.txt ===
project(AppStreamQt)
cmake_minimum_required(VERSION 3.2.0 FATAL_ERROR)

include(CMakePackageConfigHelpers)
include(GenerateExportHeader)
add_compiler_export_flags()

find_package(Qt5 REQUIRED COMPONENTS Core)
pkg_check_modules(GLIB2 REQUIRED glib-2.0>=2.46)
include(GNUInstallDirs)

set(APPSTREAMQT_SO_VERSION 2)
set(APPSTREAMQT_VERSION ${AS_VERSION})

set(CMAKE_AUTOMOC on)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_INCLUDE_CURRENT_DIR_IN_INTERFACE ON)
set(CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE ON)

if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

set(APPSTREAMQT_SRC
    category.cpp
    component.cpp
    pool.cpp
    image.cpp
    screenshot.cpp
    icon.cpp
    provided.cpp
    release.cpp
    bundle.cpp
    suggested.cpp
)

set(APPSTREAMQT_PUBLIC_HEADERS
    category.h
    component.h
    pool.h
    image.h
    screenshot.h
    icon.h
    provided.h
    release.h
    bundle.h
    suggested.h
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}
                    ${CMAKE_SOURCE_DIR}/src
                    ${CMAKE_BINARY_DIR}/src
                    ${GLIB2_INCLUDE_DIRS}
)

add_library(AppStreamQt SHARED ${APPSTREAMQT_SRC})
target_link_libraries(AppStreamQt PUBLIC Qt5::Core
                                  PRIVATE appstream
                                          ${GLIB2_LIBRARIES}
                                          ${SANITIZER_LIBS})
target_include_directories(AppStreamQt PUBLIC "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/>")
generate_export_header(AppStreamQt)

set_property(TARGET AppStreamQt PROPERTY VERSION "${APPSTREAMQT_VERSION}")
set_property(TARGET AppStreamQt PROPERTY SOVERSION "${APPSTREAMQT_SO_VERSION}" )

write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/AppStreamQtConfigVersion.cmake VERSION ${APPSTREAMQT_VERSION} COMPATIBILITY SameMajorVersion )

export(TARGETS AppStreamQt appstream
       FILE "${CMAKE_CURRENT_BINARY_DIR}/AppStreamQtTargets.cmake")

install(TARGETS AppStreamQt EXPORT AppStreamLibsTarget
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

install(FILES ${APPSTREAMQT_PUBLIC_HEADERS} ${CMAKE_CURRENT_BINARY_DIR}/appstreamqt_export.h DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/AppStreamQt")

set(ConfigPackageLocation ${CMAKE_INSTALL_LIBDIR}/cmake/AppStreamQt)

configure_package_config_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/AppStreamQtConfig.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/AppStreamQtConfig.cmake"
  INSTALL_DESTINATION ${ConfigPackageLocation}
)

install(EXPORT AppStreamLibsTarget
    FILE AppStreamQtTargets.cmake
    DESTINATION ${ConfigPackageLocation})

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/AppStreamQtConfigVersion.cmake ${CMAKE_CURRENT_BINARY_DIR}/AppStreamQtConfig.cmake DESTINATION ${ConfigPackageLocation})

add_subdirectory(tests)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -8,10 +8,14 @@
 pkg_check_modules(YAML REQUIRED yaml-0.1)
 
 if (STEMMING)
+	find_path(SNOWBALL_INCLUDE_DIR libstemmer.h HINTS "/usr/include" "/usr/include/libstemmer")
 	find_library(SNOWBALL_LIB stemmer)
-	if (NOT SNOWBALL_LIB)
+	if (NOT SNOWBALL_LIB OR NOT SNOWBALL_INCLUDE_DIR)
 		message (FATAL_ERROR "Stemming support is enabled, but libstemmer was not found. Please install the Snowball development files.")
 	endif ()
+else ()
+	set(SNOWBALL_LIB "")
+	set(SNOWBALL_INCLUDE_DIR "")
 endif ()
 
 include(GObjectIntrospectionMacros)
@@ -35,6 +39,7 @@
 		# internal
 		as-xmldata.c
 		as-yamldata.c
+		as-desktop-entry.c
 		as-cache-file.c
 		as-distro-extras.c
 		as-stemmer.c
@@ -86,6 +91,7 @@
 		as-utils-private.h
 		as-xmldata.h
 		as-yamldata.h
+		as-desktop-entry.h
 		as-cache-file.h
 		as-pool-private.h
 		as-component-private.h
@@ -101,6 +107,7 @@
 		    ${GIO2_INCLUDE_DIRS}
 		    ${LIBXML2_INCLUDE_DIR}
 		    ${YAML_INCLUDE_DIR}
+		    ${SNOWBALL_INCLUDE_DIR}
 )
 
 add_definitions("-DAS_COMPILATION")

=== tests/CMakeLists.txt ===
# CMakeLists for UAI Unit Tests

pkg_check_modules(GLIB2 REQUIRED glib-2.0>=2.46)
pkg_check_modules(GIO2 REQUIRED gio-2.0)
find_package(LibXml2 REQUIRED)
find_library(M_LIB m)

link_libraries(${SANITIZER_LIBS}
		${M_LIB}
		${GLIB2_LIBRARIES}
		${GIO2_LIBRARIES}
		${LIBXML2_LIBRARIES}
		appstream
)

include_directories(${CMAKE_BINARY_DIR}
		${CMAKE_SOURCE_DIR}/src
		${CMAKE_CURRENT_SOURCE_DIR}
		${GLIB2_INCLUDE_DIRS}
		${GIO2_INCLUDE_DIRS}
		${LIBXML2_INCLUDE_DIR}
)

set (TEST_COMMON_SRC
	as-test-utils.h
	as-test-utils.c
)

# Basic tests
add_executable(as-test-basics test-basics.c ${TEST_COMMON_SRC})
add_dependencies(as-test-basics appstream)
add_test(test-basic as-test-basics ${CMAKE_CURRENT_SOURCE_DIR})

# AppStream XML parser tests
add_executable(as-test-xmldata test-xmldata.c ${TEST_COMMON_SRC})
add_dependencies(as-test-xmldata appstream)
add_test(test-xml as-test-xmldata ${CMAKE_CURRENT_SOURCE_DIR})

# AppStream DEP-11 parser tests
add_executable(as-test-yamldata test-yamldata.c ${TEST_COMMON_SRC})
add_dependencies(as-test-yamldata appstream)
add_test(test-yaml as-test-yamldata ${CMAKE_CURRENT_SOURCE_DIR})

# AppStream data pool and cache tests
add_executable(as-test-pool test-pool.c ${TEST_COMMON_SRC})
add_dependencies(as-test-pool appstream)
add_test(test-pool as-test-pool ${CMAKE_CURRENT_SOURCE_DIR})

if(SANITIZERS)
	set_tests_properties(test-basic PROPERTIES ENVIRONMENT ASAN_OPTIONS=detect_leaks=0)
	set_tests_properties(test-xml PROPERTIES ENVIRONMENT ASAN_OPTIONS=detect_leaks=0)
	set_tests_properties(test-yaml PROPERTIES ENVIRONMENT ASAN_OPTIONS=detect_leaks=0)
	set_tests_properties(test-pool PROPERTIES ENVIRONMENT ASAN_OPTIONS=detect_leaks=0)
endif()

=== tools/CMakeLists.txt ===
# CMakeLists for the AppStream CLI tool

pkg_check_modules(GLIB2 REQUIRED glib-2.0>=2.46)
pkg_check_modules(GIO2 REQUIRED gio-2.0)
find_library(M_LIB m)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}
		    ${CMAKE_BINARY_DIR}
		    ${CMAKE_SOURCE_DIR}/src
		    ${GLIB2_INCLUDE_DIRS}
		    ${GIO2_INCLUDE_DIR}
)

set(ASCLI_SOURCES
	appstream-cli.c
	ascli-utils.h
	ascli-utils.c
	ascli-actions-mdata.h
	ascli-actions-mdata.c
	ascli-actions-validate.h
	ascli-actions-validate.c
	ascli-actions-pkgmgr.h
	ascli-actions-pkgmgr.c
	ascli-actions-misc.h
	ascli-actions-misc.c
)

# Add the appstream client tool
add_executable(appstreamcli ${ASCLI_SOURCES})
add_dependencies(appstreamcli appstream)

# the client tool uses API which is currently private...
# needs to be sorted out in future
add_definitions ("-DAS_COMPILATION")

target_link_libraries(appstreamcli
		${SANITIZER_LIBS}
		${M_LIB}
		${GLIB2_LIBRARIES}
		${GIO2_LIBRARIES}
		appstream
)

install(TARGETS appstreamcli DESTINATION ${CMAKE_INSTALL_BINDIR})

=== contrib/its/CMakeLists.txt ===
# Gettext ITS information for MetaInfo files

install(FILES metainfo.its metainfo.loc
        DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/gettext/its)

=== contrib/vapi/CMakeLists.txt ===
--- 
+++ 
@@ -22,6 +22,6 @@
 )
 add_custom_target(vapi ALL DEPENDS ${APPSTREAM_VAPI_FILE})
 
-install(FILES ${APPSTREAM_VAPI_FILE} DESTINATION share/vala/vapi)
+install(FILES ${APPSTREAM_VAPI_FILE} DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/vala/vapi)
 
 endif()

=== qt/tests/CMakeLists.txt ===
# CMakeLists for AppStreamQt Tests

find_package(Qt5 COMPONENTS Test REQUIRED)

configure_file (${CMAKE_CURRENT_SOURCE_DIR}/testpaths.h.in ${CMAKE_CURRENT_BINARY_DIR}/testpaths.h @ONLY)

add_executable(asqt-pool-test asqt-pool-test.cpp)
target_link_libraries(asqt-pool-test
    ${SANITIZER_LIBS}
    Qt5::Core
    Qt5::Test
    AppStreamQt
)
add_test(asqt-pool-test asqt-pool-test)

if(SANITIZERS)
	set_tests_properties(asqt-pool-test PROPERTIES ENVIRONMENT ASAN_OPTIONS=detect_leaks=0)
endif()

=== debian/changelog ===
appstream (0.10.6-1~ubuntu16.04.2) xenial-backports; urgency=medium

  * d/p/0001-Revert-apt-Do-not-enable-any-icon-downloads-by-defau.patch:
    Re-enable icon downloads by default - 16.04 doesn't have the
    corresponding fixes in software centers. (LP: #1661460)
  * debian/control: Remove the Breaks that were added for the above.

 -- Iain Lane <iain@orangesquash.org.uk>  Sun, 05 Feb 2017 10:27:19 +0000

appstream (0.10.6-1~ubuntu16.04.1) xenial-backports; urgency=medium

  * Backport to 16.04, with one change:
    - Lower the required Qt version to 5.4

 -- Iain Lane <iain@orangesquash.org.uk>  Wed, 01 Feb 2017 12:02:22 +0000

appstream (0.10.6-1) unstable; urgency=medium

  * New upstream version: 0.10.6
    - APT will no longer download icons by default if
      there are no GUI frontends available that use them (Closes: #847543)
    - AppStream GUIs will need to tell APT that they require icons.

 -- Matthias Klumpp <mak@debian.org>  Sun, 22 Jan 2017 19:56:54 +0100

appstream (0.10.5-1) unstable; urgency=medium

  * New upstream version: 0.10.5
    - Uses fnmatch on modalias provides (Closes: #841160)
    - More verbose error messages on cache update failures (Closes: #820774)
  * Update symbols file

 -- Matthias Klumpp <mak@debian.org>  Thu, 22 Dec 2016 18:06:34 +0100

appstream (0.10.4-1) unstable; urgency=medium

  * New upstream version: 0.10.4
  * Bump debhelper compat level

 -- Matthias Klumpp <mak@debian.org>  Sun, 27 Nov 2016 19:14:15 +0100

appstream (0.10.3-1) unstable; urgency=medium

  * New upstream version: 0.10.3
  * Update Qt package name for API break

 -- Matthias Klumpp <mak@debian.org>  Tue, 01 Nov 2016 16:46:12 +0100

appstream (0.10.2-1) unstable; urgency=medium

  * New upstream version: 0.10.2
  * Update dependencies
    - Drop intltool
    - Add itstool, gettext
    - Update minimum qtbase version
  * Update symbols file

 -- Matthias Klumpp <mak@debian.org>  Mon, 10 Oct 2016 20:05:52 +0200

appstream (0.10.1-2) unstable; urgency=medium

  * Install metainfo file

 -- Matthias Klumpp <mak@debian.org>  Mon, 03 Oct 2016 21:12:00 +0200

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,11 @@
 Priority: optional
 Maintainer: Matthias Klumpp <mak@debian.org>
 Build-Depends: cmake (>= 2.8),
-               debhelper (>= 9.0.0),
+               debhelper (>= 10),
+               gettext,
                gobject-introspection,
                gtk-doc-tools,
-               intltool,
+               itstool,
                libgirepository1.0-dev (>= 1.32),
                libglib2.0-dev (>= 2.46),
                libstemmer-dev,
@@ -18,7 +19,7 @@
 Standards-Version: 3.9.8
 Homepage: http://www.freedesktop.org/wiki/Distributions/AppStream/
 Vcs-Git: https://anonscm.debian.org/git/pkg-packagekit/appstream.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-packagekit/appstream.git
+Vcs-Browser: https://anonscm.debian.org/git/pkg-packagekit/appstream.git
 
 Package: appstream
 Architecture: any
@@ -28,7 +29,7 @@
 Provides: appstream-index
 Description: Software component metadata management
  AppStream is a metadata specification, allowing to write metadata for
- software projects in a general-purpose format.
+ software projects in a standardized format.
  It provides facilities to easily access and transform the data, as well
  as a few additional services to allow building feature-rich software center
  applications.
@@ -50,7 +51,7 @@
          ${shlibs:Depends}
 Description: Library to access AppStream services
  AppStream is a metadata specification, allowing to write metadata for
- software projects in a general-purpose format. This allows software centers
+ software projects in a standardized format. This allows software centers
  to display useful information for not installed software, as well as
  determining software the user might want to install (e.g. to open an
  unknown file type or to make missing firmware available).
@@ -70,7 +71,7 @@
 Suggests: appstream-generator
 Description: Library to access AppStream services (development files)
  AppStream is a metadata specification, allowing to write metadata for
- software projects in a general-purpose format. This allows software centers
+ software projects in a standardized format. This allows software centers
  to display useful information for not installed software, as well as
  determining software the user might want to install (e.g. to open an
  unknown file type or to make missing firmware available).
@@ -88,14 +89,14 @@
 Replaces: gir1.2-appstream (<< 0.10.1)
 Description: Library to access AppStream services (introspection data)
  AppStream is a metadata specification, allowing to write metadata for
- software projects in a general-purpose format. This allows software centers
+ software projects in a standardized format. This allows software centers
  to display useful information for not installed software, as well as
  determining software the user might want to install (e.g. to open an
  unknown file type or to make missing firmware available).
  .
  This package contains introspection data for the AppStream library.
 
-Package: libappstreamqt1
+Package: libappstreamqt2
 Architecture: any
 Section: libs
 Multi-Arch: same
@@ -104,7 +105,7 @@
          ${shlibs:Depends}
 Description: Qt5 library to access AppStream services
  AppStream is a metadata specification, allowing to write metadata for
- software projects in a general-purpose format. This allows software centers
+ software projects in a standardized format. This allows software centers
  to display useful information for not installed software, as well as
  determining software the user might want to install (e.g. to open an
  unknown file type or to make missing firmware available).
@@ -116,12 +117,12 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: libappstreamqt1 (= ${binary:Version}),
+Depends: libappstreamqt2 (= ${binary:Version}),
          qtbase5-dev (>= 5.4),
          ${misc:Depends}
 Description: Qt5 library to access AppStream services (development files)
  AppStream is a metadata specification, allowing to write metadata for
- software projects in a general-purpose format. This allows software centers
+ software projects in a standardized format. This allows software centers
  to display useful information for not installed software, as well as
  determining software the user might want to install (e.g. to open an
  unknown file type or to make missing firmware available).
@@ -137,7 +138,7 @@
 Suggests: appstream
 Description: Developer documentation for AppStream
  AppStream is a metadata specification, allowing to write metadata for
- software projects in a general-purpose format. This allows software centers
+ software projects in a standardized format. This allows software centers
  to display useful information for not installed software, as well as
  determining software the user might want to install (e.g. to open an
  unknown file type or to make missing firmware available).

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#export DH_VERBOSE=1

AS_CONFIGURE_ARGS = -DQT=ON \
		-DAPT_SUPPORT=ON \
		-DVAPI=ON


# Define install target dir
INSTALLDIR = $(CURDIR)/debian/tmp

%:
	dh $@ --with gir

override_dh_auto_configure:
	dh_auto_configure -- $(AS_CONFIGURE_ARGS)

override_dh_auto_install:
	dh_auto_install --destdir=$(INSTALLDIR)

override_dh_install:
	dh_install --list-missing
